###########################
# ListMate_Ext
###########################
# Python Extensions to the ListMate product
# Author: 	Heiko Stoermer, innominate AG Germany, heiko.stoermer@innominate.de
# License:	GPL
# Created:	20000412
###########################

import sys
import time
import string
import random


import Globals 
#import AccessControl.User
#from cStringIO import StringIO
#from OFS import Image

#
#def addUser(self,parent,id,password,roles,domains,REQUEST=None):
#	parent._addUser(id, password, password, roles, domains,None)

############
# csv_importer
############
# utility for importing csv separated files into ListMate objects.
# Will add columns its parent ListMate object and create a 
# ListMate_ListItem for every line in the file starting at the 2nd line.
# (line 1 MUST contain valid column names)
#
# currently supports tab separated files only
#
# it calls the dtml-method ListMate_ListItem_add in Zope
#
def csv_importer(self,fileobj,REQUEST):
	rec_count = 0	# how many lines have we imported
	if REQUEST.has_key('sep') and REQUEST['sep'] != '':
		sep = REQUEST['sep']
	else:	
		sep = '\t'
	#
	# get column name from first line of input file
	#
	line = fileobj.readline()
	if not line: return 0 				# error
	cols = string.split(line,sep)
	#
	# set columns as attributes of the ListMate object (which is self)
	#
	for col in cols:
		label = string.join(['col',col],'_')
		if not self.hasProperty(label):
			self.manage_addProperty(label,col,'string',None)
	#
	# now read the file and create ListItems
	#

	# tell the called dtml-method ListMate_ListItem_add not to redir as it would normally do
	REQUEST.set('noredir',1)
	while 1: # don't worry, we won't loop forever ;-)
		line = fileobj.readline()
		if not line: break # see?

		# create an id for the new ListItem
		REQUEST.set('id',str(   int(int(time.time())  * random.random()) ))

		# create the ListItem
		self.ListMate_ListItem_add(self,REQUEST)
		Item = self._getOb(REQUEST['id'])

		# set its attributes
		vals = string.split(line,sep,len(cols)-1)
		for i in range(len(cols)):
			# sometimes we do not have values for a column...
			if i < len(vals):
				Item._updateProperty(string.join(['col',cols[i]],'_'),vals[i])	
			else:
				pass
		rec_count = rec_count + 1
	return rec_count	
